package sd.layout;

import Jcg.geometry.Vector_3;
import jdg.graph.AdjacencyListGraph;
import jdg.graph.Node;

/**
 * This class define the abstract model for the computation of repulsive forces
 * 
 * @author Luca Castelli Aleardi, Ecole Polytechnique
 * @version april 2017
 */
public abstract class ForceComputation {

	public ForceModel force;
	
	/**
	 * Compute the displacement of vertex 'u', due to repulsive forces (of all nodes): slow version (without octrees)
	 * 
	 * @param u  the vertex to which repulsive forces are applied
	 * @return 'displacement' a 3d vector storing the displacement of vertex 'u'
	 */	
	public abstract Vector_3 computeRepulsiveForce(AdjacencyListGraph g, Node u, double tol);

}
