package sd.layout;

import Jcg.geometry.Point_3;
import Jcg.polyhedron.Polyhedron_3;
import jdg.graph.AdjacencyListGraph;

public class RandomLayout extends SphericalLayout {
	/**
	 * Initialize the parameters of the force-directed layout
	 * 
	 *  @param g  input graph to draw
	 *  @param C  step length
	 */
	public RandomLayout(AdjacencyListGraph g, Polyhedron_3<Point_3> mesh) {
		System.out.print("Initializing random layout...");
		if(g==null) {
			System.out.println("Input graph not defined");
			System.exit(0);
		}
		this.g=g;
		this.mesh=mesh;
		int N=g.sizeVertices();
		
		this.setRandomPointsOnSphere(g);
		System.out.println("done ("+N+" nodes)");
		System.out.println(this.toString());
	}
	
	/**
	 * Enable cooling process
	 */	
	public void enableCooling() {
	}

	/**
	 * Enable cooling process
	 */	
	public void disableCooling() {
	}

	/**
	 * Perform one iteration of the Force-Directed algorithm.
	 * Positions of vertices are updated according to their mutual attractive and repulsive forces.
	 * 
	 * @param iterations  number of iterations to perform
	 */	
	public void computeOneIteration() {
		this.setRandomPointsOnSphere(g);
	}
	
	/**
	 * Perform 'k' iteration of the Force-Directed algorithm.
	 * Positions of vertices are updated according to their
	 * mutual attractive and repulsive forces.
	 * 
	 * @param iterations  number of iterations to perform
	 */	
	public void computeLayout(int iterations) {
		this.setRandomPointsOnSphere(g);
	}
	
	/**
	 * Not supported
	 */	
	@Deprecated
	public void computeLayout(double tolerance) {
		throw new Error("This class is not supported anymore");
	}

	/**
	 * Compute and return the potential energy for the force-directed layout
	 */	
	public double computeTotalEnergy() {
		System.out.print("Computing potential energy of the layout: ");
		
		return 0.;
	}
	
	/**
	 * Cooling system: the temperature decreases linearly at each iteration
	 * 
	 * Remark: the temperature is assumed to remain strictly positive (>=minTemperature)
	 */	
	protected void cooling() {
	}
	
	public String toString() {
		String result="Random layout\n";
		
		return result;
	}

}
