package sd.util;

import Jcg.geometry.Point_3;
import Jcg.geometry.Vector_3;

public class Matrix_3D {
	public double[][]matrice;
	
	public Matrix_3D(double a11, double a12, double a13,double a21, double a22, double a23,double a31, double a32, double a33){
		this.matrice=new double[3][3];
		this.matrice[0][0]=a11;
		this.matrice[0][1]=a12;
		this.matrice[0][2]=a13;
		this.matrice[1][0]=a21;
		this.matrice[1][1]=a22;
		this.matrice[1][2]=a23;
		this.matrice[2][0]=a31;
		this.matrice[2][1]=a32;
		this.matrice[2][2]=a33;
	}
	
	public double[][] getMatrix(){
		return this.matrice;
	}
	
	public Point_3 productPoint(Point_3 u){
		double px=0.;
		double py=0.;
		double pz=0.;
		px=u.x*this.matrice[0][0]+u.y*this.matrice[0][1]+u.z*this.matrice[0][2];
		py=u.x*this.matrice[1][0]+u.y*this.matrice[1][1]+u.z*this.matrice[1][2];
		pz=u.x*this.matrice[2][0]+u.y*this.matrice[2][1]+u.z*this.matrice[2][2];
		return new Point_3(px,py,pz);
	}
	
	public static Matrix_3D rotationMatrix(Vector_3 u, double angle){
		double c=Math.cos(angle);
		double s=Math.sin(angle);
		return new Matrix_3D(u.x*u.x*(1.-c)+c,u.x*u.y*(1.-c)-u.z*s,u.x*u.z*(1.-c)+u.y*s,u.x*u.y*(1.-c)+u.z*s,u.y*u.y*(1.-c)+c,u.y*u.z*(1.-c)-u.x*s,u.x*u.z*(1.-c)-u.y*s,u.y*u.z*(1.-c)+u.x*s,u.z*u.z*(1.-c)+c);
	}


}
