package sd.util;

import java.util.LinkedList;

import tc.TC;

/**
 * This class will help us to show the different kinds of statistical results
 * 
 * @author Gaspard Denis (2017)
 *
 */
public class Stat {

	public LinkedList<Double> angleMean;//It contains the mean of the angles for each iteration
	public LinkedList<Double> edgeLength;//It contains the mean of the length of the edges for each iteration
	public LinkedList<Double> energy;//It contains the energy of the system for each iteration
	public LinkedList<Double> time;//It contains the time since the beginning of the launch of the algorithm
	public LinkedList<Double> timeAttractive;//It contains the time of the computation of the attractive forces for each iteration
	public LinkedList<Double> timeRepulsive;//It contains the time of the computation of the repulsive forces for each iteration
	public String algo;//Contains the name of the algorithm studied
	public boolean b;//Boolean that tells us if we want to study attractive and repulsive forces statistics (FR91 case) or not (other algorithms)
	public LinkedList<Double> ratioArea;//It contains the ratio between the minimum area of the triangles and the maximum area of the triangles
	public LinkedList<Double> crossing;//It contains the number of crossing for each iteration
	public int IterationCountNullCrossing;//iterationCount when the number of crossing starts being null
	public double TimeNullCrossing;//time when the number of crossing starts being null
	
	public Stat(String algo, boolean b){
		this.algo=algo;
		this.angleMean=new LinkedList<Double>();
		this.edgeLength=new LinkedList<Double>();
		this.energy=new LinkedList<Double>();
		this.time=new LinkedList<Double>();
		this.b=b;
		if(this.b==true){
			this.timeAttractive=new LinkedList<Double>();
			this.timeRepulsive=new LinkedList<Double>();
		}
		else{
			this.timeAttractive=null;
			this.timeRepulsive=null;
		}
		this.ratioArea=new LinkedList<Double>();
		this.crossing=new LinkedList<Double>();
		this.IterationCountNullCrossing=-1;
		this.TimeNullCrossing=-1.;
		
	}
	
	public static void save(String filename, LinkedList<Double> liste) {
		System.out.print("Saving data to file "+filename+"...");
		TC.ecritureDansNouveauFichier(filename);
		
		int count=0;
		for(Double d: liste) {
			TC.println(""+count+" "+d);
			count++;
		}
		
		TC.ecritureSortieStandard();
		System.out.println("done");
	}

	public static void save(String filename, LinkedList<Double> liste, LinkedList<Double> time) {
		System.out.println("Saving data to file "+filename+"...");
		TC.ecritureDansNouveauFichier(filename);
		
		//double[] timeArray=new double[time.size()];
		
		int count=0;
		for(Double d: liste) {
			TC.println(""+time.get(count)+" "+d);
			count++;
		}
		
		TC.ecritureSortieStandard();
		System.out.print("done");
	}

}
